#<<<
## no critic
use utf8;
package Stanford::Certificate::Result::Request;

# Created by DBIx::Class::Schema::Loader
# DO NOT MODIFY THE FIRST PART OF THIS FILE

=head1 NAME

Stanford::Certificate::Result::Request

=cut

use strict;
use warnings;
use 5.026;

use base 'DBIx::Class::Core';

=head1 TABLE: C<requests>

=cut

__PACKAGE__->table("requests");

=head1 ACCESSORS

=head2 id

  data_type: 'integer'
  is_auto_increment: 1
  is_nullable: 0

=head2 cn

  data_type: 'varchar'
  is_nullable: 0
  size: 100

=head2 cancelled

  data_type: 'tinyint'
  is_nullable: 0

=head2 declined

  data_type: 'tinyint'
  is_nullable: 0

=head2 rejected

  data_type: 'tinyint'
  is_nullable: 0

=head2 test

  data_type: 'tinyint'
  is_nullable: 0

=head2 requester_sunetid

  data_type: 'varchar'
  is_nullable: 0
  size: 12

=head2 requester_fullname

  data_type: 'varchar'
  is_nullable: 1
  size: 60

=head2 requester_email

  data_type: 'varchar'
  is_nullable: 0
  size: 60

=head2 requester_affiliation

  data_type: 'varchar'
  is_nullable: 1
  size: 30

=head2 requester_department

  data_type: 'varchar'
  is_nullable: 1
  size: 90

=head2 requester_comments

  data_type: 'text'
  is_nullable: 1

=head2 requester_alternatives

  data_type: 'text'
  is_nullable: 1

=head2 server_type_id

  data_type: 'integer'
  is_foreign_key: 1
  is_nullable: 0

=head2 contact_email

  data_type: 'varchar'
  is_nullable: 0
  size: 60

=head2 csr

  data_type: 'text'
  is_nullable: 0

=head2 pk_algorithm

  data_type: 'varchar'
  is_nullable: 0
  size: 30

=head2 reissue

  data_type: 'tinyint'
  is_nullable: 0

=head2 duration

  data_type: 'integer'
  is_nullable: 0

=head2 alternatives

  data_type: 'text'
  is_nullable: 1

=head2 order_number

  data_type: 'varchar'
  is_nullable: 1
  size: 16

=head2 approved

  data_type: 'tinyint'
  is_nullable: 0

=head2 fulfilled

  data_type: 'tinyint'
  is_nullable: 0

=head2 certificate_id

  data_type: 'integer'
  is_foreign_key: 1
  is_nullable: 1

=head2 approval_contacts

  data_type: 'varchar'
  is_nullable: 0
  size: 100

=head2 renewid

  data_type: 'varchar'
  is_nullable: 1
  size: 30

=head2 certificate_type_id

  data_type: 'integer'
  is_foreign_key: 1
  is_nullable: 0

=head2 incommon_cert_number

  data_type: 'integer'
  is_nullable: 1

=head2 incommon_cert_name

  data_type: 'varchar'
  is_nullable: 1
  size: 60

=head2 notes

  data_type: 'text'
  is_nullable: 1

=head2 suppress_notifications

  data_type: 'tinyint'
  is_nullable: 0

=head2 created_at

  data_type: 'datetime'
  datetime_undef_if_invalid: 1
  is_nullable: 0

=head2 updated_at

  data_type: 'datetime'
  datetime_undef_if_invalid: 1
  is_nullable: 0

=cut

__PACKAGE__->add_columns(
  "id",
  { data_type => "integer", is_auto_increment => 1, is_nullable => 0 },
  "cn",
  { data_type => "varchar", is_nullable => 0, size => 100 },
  "cancelled",
  { data_type => "tinyint", is_nullable => 0 },
  "declined",
  { data_type => "tinyint", is_nullable => 0 },
  "rejected",
  { data_type => "tinyint", is_nullable => 0 },
  "test",
  { data_type => "tinyint", is_nullable => 0 },
  "requester_sunetid",
  { data_type => "varchar", is_nullable => 0, size => 12 },
  "requester_fullname",
  { data_type => "varchar", is_nullable => 1, size => 60 },
  "requester_email",
  { data_type => "varchar", is_nullable => 0, size => 60 },
  "requester_affiliation",
  { data_type => "varchar", is_nullable => 1, size => 30 },
  "requester_department",
  { data_type => "varchar", is_nullable => 1, size => 90 },
  "requester_comments",
  { data_type => "text", is_nullable => 1 },
  "requester_alternatives",
  { data_type => "text", is_nullable => 1 },
  "server_type_id",
  { data_type => "integer", is_foreign_key => 1, is_nullable => 0 },
  "contact_email",
  { data_type => "varchar", is_nullable => 0, size => 60 },
  "csr",
  { data_type => "text", is_nullable => 0 },
  "pk_algorithm",
  { data_type => "varchar", is_nullable => 0, size => 30 },
  "reissue",
  { data_type => "tinyint", is_nullable => 0 },
  "duration",
  { data_type => "integer", is_nullable => 0 },
  "alternatives",
  { data_type => "text", is_nullable => 1 },
  "order_number",
  { data_type => "varchar", is_nullable => 1, size => 16 },
  "approved",
  { data_type => "tinyint", is_nullable => 0 },
  "fulfilled",
  { data_type => "tinyint", is_nullable => 0 },
  "certificate_id",
  { data_type => "integer", is_foreign_key => 1, is_nullable => 1 },
  "approval_contacts",
  { data_type => "varchar", is_nullable => 0, size => 100 },
  "renewid",
  { data_type => "varchar", is_nullable => 1, size => 30 },
  "certificate_type_id",
  { data_type => "integer", is_foreign_key => 1, is_nullable => 0 },
  "incommon_cert_number",
  { data_type => "integer", is_nullable => 1 },
  "incommon_cert_name",
  { data_type => "varchar", is_nullable => 1, size => 60 },
  "notes",
  { data_type => "text", is_nullable => 1 },
  "suppress_notifications",
  { data_type => "tinyint", is_nullable => 0 },
  "created_at",
  {
    data_type => "datetime",
    datetime_undef_if_invalid => 1,
    is_nullable => 0,
  },
  "updated_at",
  {
    data_type => "datetime",
    datetime_undef_if_invalid => 1,
    is_nullable => 0,
  },
);

=head1 PRIMARY KEY

=over 4

=item * L</id>

=back

=cut

__PACKAGE__->set_primary_key("id");

=head1 RELATIONS

=head2 certificate

Type: belongs_to

Related object: L<Stanford::Certificate::Result::Certificate>

=cut

__PACKAGE__->belongs_to(
  "certificate",
  "Stanford::Certificate::Result::Certificate",
  { id => "certificate_id" },
  {
    is_deferrable => 1,
    join_type     => "LEFT",
    on_delete     => "RESTRICT",
    on_update     => "RESTRICT",
  },
);

=head2 certificate_type

Type: belongs_to

Related object: L<Stanford::Certificate::Result::CertificateType>

=cut

__PACKAGE__->belongs_to(
  "certificate_type",
  "Stanford::Certificate::Result::CertificateType",
  { id => "certificate_type_id" },
  { is_deferrable => 1, on_delete => "RESTRICT", on_update => "RESTRICT" },
);

=head2 eventlogs

Type: has_many

Related object: L<Stanford::Certificate::Result::Eventlog>

=cut

__PACKAGE__->has_many(
  "eventlogs",
  "Stanford::Certificate::Result::Eventlog",
  { "foreign.request_id" => "self.id" },
  { cascade_copy => 0, cascade_delete => 0 },
);

=head2 server_type

Type: belongs_to

Related object: L<Stanford::Certificate::Result::ServerType>

=cut

__PACKAGE__->belongs_to(
  "server_type",
  "Stanford::Certificate::Result::ServerType",
  { id => "server_type_id" },
  { is_deferrable => 1, on_delete => "RESTRICT", on_update => "RESTRICT" },
);

## use critic
#>>>

# Created by DBIx::Class::Schema::Loader v0.07046 @ 2019-06-21 09:43:40
# DO NOT MODIFY THIS OR ANYTHING ABOVE! md5sum:T+HlE+Zcj4AJHTZJdVgXkg

## no critic (Subroutines::RequireArgUnpacking);
## no critic (CodeLayout::ProhibitParensWithBuiltins);

# You can replace this text with custom content, and it will be preserved on regeneration
use Stanford::PKObj ;
use Stanford::Orange::Util qw/ trim tempfile slurp spew run_command run_under_keytab / ;
use Stanford::Certificate::Misc qw/ mysql_time mysql_time_local dedupe_array / ;
use Stanford::Certificate::X509 ;
use Stanford::Certificate::Log ;
use Stanford::Certificate::Mail ;
use Stanford::Certificate::Notification ;
use Stanford::NetDBInfo ;

use Carp ;
use Data::Dumper ;
use English ;
use JSON ;
use Net::Remctl ;

sub new {
  my ( $class, $attrs ) = @_;

  $attrs->{'created_at'} = mysql_time()  unless defined $attrs->{'created_at'};
  $attrs->{'updated_at'} = $attrs->{'created_at'} unless defined $attrs->{'updated_at'};
  $attrs->{'cancelled'}  = 0             unless defined $attrs->{'cancelled'};
  $attrs->{'test'}       = 1             unless defined $attrs->{'test'};
  $attrs->{'reissue'}    = 0             unless defined $attrs->{'reissue'};
  $attrs->{'approved'}   = 0             unless defined $attrs->{'approved'};
  $attrs->{'declined'}   = 0             unless defined $attrs->{'declined'};
  $attrs->{'rejected'}   = 0             unless defined $attrs->{'rejected'};
  $attrs->{'fulfilled'}  = 0             unless defined $attrs->{'fulfilled'};
  $attrs->{'suppress_notifications'} = 0 unless defined $attrs->{'suppress_notifications'};

  my $new = $class->next::method($attrs);
  return $new;
}

# Returns 1 if the certificate is ready to be collected from the
# InCommon Certificate Manager, 0 otherwise.
sub isReady
{
  my $self = shift ;
  my ($credentials_file) = @_ ;

  return Stanford::Certificate::Misc::ready($self->order_number(),
                                            $credentials_file,
                                            $self->test) ;
}

sub is_declined {
  my $self = shift ;
  if (!defined($self->declined()) || !$self->declined()) {
      return 0 ;
  } else {
      return 1 ;
  }
}

sub is_rejected {
  my $self = shift ;
  if (!defined($self->rejected()) || !$self->rejected()) {
      return 0 ;
  } else {
      return 1 ;
  }
}

# Return 1 id $name starts with "*." 0 otherwise.
# NOT a method.
sub is_wildcard {
    my ($name) = @_ ;
    return ($name =~ m{^[*][.]}xsm) ;
}


sub approval_contacts_array
{
  my $self = shift ;
  return split(/,/xsm, $self->approval_contacts()) ;
}

# A request can have one of these statuses:
#  new       (not yet submitted to InCommon Certificate Manager)
#  ordered   (submitted but not yet approved)
#  approved  (approved but not yet fulfilled)
#  fulfilled (fulfilled but not yet collected)
#  collected (collected (stored in the database))
#  declined  (a cert admin declined the request)
#
#  If no credentials_file is passed, the three statuses 'ordered', approved',
#  and 'fulfilled' are replaced by 'pending'.
sub status
{
  my $self = shift ;

  my ($credentials_file) = @_ ;

  if ($self->declined())
  {
    return 'declined' ;
  }
  elsif ($self->cancelled())
  {
    return 'cancelled' ;
  }
  elsif (!$self->order_number())
  {
    return 'new' ;
  }
  else
  {
    my $certificate_id = $self->certificate_id() ;
    if (defined($certificate_id) && (($certificate_id + 0) > 0))
    {
      # If the request did not get approved before fulfilled, set the
      # approval now
      if (!$self->approved())
      {
        my $status = $self->get_status_from_cert_manager($credentials_file) ;
        if ($status =~ m{approved|fulfilled}xsm)
        {
          $self->approved(1) ;
          $self->update() ;
        }
        elsif ($status =~ m{declined}xsm)
        {
          # This certificate request has been declined, so set the
          # declined attribute as well as the cancelled attibute.
          $self->declined(1) ;
          $self->cancelled(1) ;
          $self->update() ;
        }
        else
        {
          croak 'certificate request ' . $self->id() . ' has a certificate id ' .
              'but the Certificate Manager says the request is not ' .
              'approved or fulfilled; this is inconsistent' ;
        }
      }
      return 'collected' ;
    }
    else
    {
      if ($credentials_file)
      {
        # If we get here we are either in the ordered or approved state.
        # This will require a web services call.
        return $self->get_status_from_cert_manager($credentials_file) ;
      }
      else
      {
        return 'pending' ;
      }
    }
  }
}

# Returns one of:
#
#  * approved
#  * ordered
#  * fulfilled
#  * declined
sub get_status_from_cert_manager
{
  my $self = shift ;
  my ($credentials_file) = @_ ;

  if ($credentials_file)
  {
    my $status = Stanford::Certificate::Misc::status($self->order_number(),
                                                     $credentials_file,
                                                     $self->test()) ;

    if    ($status =~ m{not ready: approved but not yet fulfilled}sm)
    {
      return 'approved' ;
    }
    elsif ($status =~ m{not ready: submitted but not yet approved}sm)
    {
      return 'ordered' ;
    }
    elsif ($status =~ m{not ready: declined}sm)
    {
      return 'declined' ;
    }
    elsif ($status eq 'ready')
    {
      return 'fulfilled' ;
    }
    else
    {
        my $order_number = $self->order_number() ;
        croak "error: unknown status '$status' (order number $order_number)" ;
    }
  }
  else
  {
    croak 'error: cannot get status without a credentials file' ;
  }
}

sub contact_addresses
{
  my ($self) = shift ;

  my @contact_addresses = () ;

  if ($self->requester_email())
  {
    push(@contact_addresses, $self->requester_email()) ;
  }

  if ($self->contact_email())
  {
    push(@contact_addresses, $self->contact_email()) ;
  }

  # Remove duplicate e-mail addresses and return.
  return dedupe_array(\@contact_addresses) ;
}

# If the request has an order number but is not approved, see if it has
# been approved yet. If the request is approved but not fulfilled, see
# if it is fulfilled.
#
# Return the new status if there is a status change, otherwise return a false value.
sub update_status
{
  my ($self) = shift ;

  my ($incommon_cm_credentials_file) = @_ ;

  my $new_status = undef ;

  if ($self->cancelled()) {
    return  ;
  } else {
    my $order_number = $self->order_number() ;
    my $approved     = $self->approved() ;
    my $fulfilled    = $self->fulfilled() ;

    # If the request has an order number but either has not been seen to
    # be approved or has not been seen to be fulfilled, check to see if it
    # has, in fact, been approved and/or fulfilled.
    if ($order_number)
    {
      if (!$approved)
      {
        my $current_status = $self->status($incommon_cm_credentials_file) ;
        if ($current_status =~ m{approved}xsm)
        {
          $self->approved(1) ;
          $self->update() ;
          $new_status = $current_status ;
        }
      }
      elsif (!$fulfilled)
      {
        my $current_status = $self->status($incommon_cm_credentials_file) ;
        if ($current_status =~ m{fulfilled}xsm)
        {
          $self->fulfilled(1) ;
          $self->update() ;
          my $certificate_id = $self->collect($incommon_cm_credentials_file) ;
          $new_status = $self->status($incommon_cm_credentials_file) ;
        }
      }
    }
  }

  return $new_status ;
}


sub get_schema
{
  my ($self) = shift ;
  return $self->result_source->schema ;
}

# This is only useful for testing (we throw away the key file).
sub make_csr
{
  my ($self) = shift ;

  my $cn = $self->cn() ;
  if (!$cn)
  {
    croak 'cannot make a CSR without a common name' ;
  }

  my $filename_csr = tempfile() ;
  my $filename_key = tempfile() ;

  my $csr = Stanford::Certificate::X509::make_csr($cn, $filename_csr, $filename_key) ;

  $self->csr($csr) ;

  unlink($filename_csr) ;
  unlink($filename_key) ;

  return $csr ;
}

# Returns undef if it cannot be inferred.
sub derive_pk_algorithm_from_csr {
    my ($csr) = @_ ;

    my @objects = Stanford::PKObj::get_objects_from_string($csr) ;
    if (scalar(@objects) > 0) {
        my $pkobj_csr = $objects[0] ;
        my ($keysize, $pk_algorithm) = $pkobj_csr->get_keyinfo() ;
        return $pk_algorithm ;
    }
    croak 'could not infer PK algorithm from CSR' ;
}

sub saveme {
  my ($self) = shift ;

  # Do some validations.

  # DURATION
  my $duration = $self->duration() ;
  if (!defined($duration)) {
    croak 'duration is not defined' ;
  } elsif ((q{} . $duration) !~ m{^(1|2|3)$}xsm) {
    croak 'duration must be one of 1, 2, or 3' ;
  }

  # ## ####  # ## ####  # ## ####  # ## ####  # ## ####  # ## ####
  my $die_if_undef_or_empty_fref = sub {
    my ($value, $label) = @_ ;
    if (!$value || !trim($value)) {
      croak "$label must be defined and not-empty" ;
    }
    return ;
  } ;
  # ## ####  # ## ####  # ## ####  # ## ####  # ## ####  # ## ####

  $die_if_undef_or_empty_fref->($self->cn(), 'cn') ;
  $die_if_undef_or_empty_fref->($self->requester_sunetid(), 'requester_sunetid') ;
  $die_if_undef_or_empty_fref->($self->requester_email(), 'requester_email') ;
  $die_if_undef_or_empty_fref->($self->contact_email(), 'contact_email') ;
  $die_if_undef_or_empty_fref->($self->csr(), 'csr') ;


  # Get the pk_algorithm
  my $csr = $self->csr() ;

  my $pk_algorithm ;
  eval {
      $pk_algorithm = derive_pk_algorithm_from_csr($csr) ;
  } ;
  if ($EVAL_ERROR) {
      $pk_algorithm = 'unknown' ;
  }
  $self->pk_algorithm($pk_algorithm) ;

  my $current_time = mysql_time() ;
  $self->updated_at($current_time) ;

  # Is this an insert or update?
  if (!$self->id()) {
    return $self->insert() ;
  } else {
    return $self->update() ;
  }

}

# Sends this request to InCommon
# If successful, the order_number property will be set to a
# non-empty string and the method returns 1.
#
# If this request has been cancelled, raise an exception.
#
# If not successful, dies.
sub send {
  my ($self) = shift ;

  my ($cm_credentials_file) = @_ ;

  if ($self->isCancelled()) {
    croak 'you cannot send a cancelled request' ;
  }

  # Is this a test cert?
  my $test = $self->test() ;
  if (!defined($test)) {
    croak 'test property not defined' ;
  }

  my $test_flag = q{} ;
  if ($test) {
    $test_flag = '--test ' ;
    $self->log_info('(send) sending to test certificate manager');
  } else {
    $self->log_info('(send) sending to production certificate manager');
  }

  # Is this a wildcard certificate?
  my $wildcard_option = q{} ;
  my $certificate_type = $self->certificate_type() ;
  if ($certificate_type->name() =~ m{wildcard}ixsm) {
      $wildcard_option = '--wildcard ' ;
  }

  # Get duration.
  my $duration = $self->duration() ;

  # Get InCommon server type id.
  my $server_type = $self->server_type() ;
  if (!$server_type)
  {
    croak 'no server type!' ;
  }
  my $server_type_name = $server_type->name() ;

  my $server_type_incommon = $server_type->incommonid() ;
  if (!defined($server_type_incommon)) {
    croak 'could not find InCommon server type!' ;
  }

  # Create a tempfile containing the csr string
  my $csr_string = $self->csr() ;
  if (!$csr_string || (length($csr_string) < 50)) {
    croak 'csr string does not appear to be valid' ;
  }
  my $csr_file = tempfile() ;
  spew($csr_string, $csr_file) ;

  # my ($username, $password) = Stanford::Certificate::Misc::get_username_password($cm_credentials_file) ;

  # Construct the subject alternative names string (if there are any)
  my $sans_option = q{} ;
  my $requester_alternatives = $self->requester_alternatives() ;
  if ($requester_alternatives) {
      $sans_option = "--subject-alternative-names $requester_alternatives " ;
  }

  my $ecc_flaq = q{} ;
  if ($self->is_ecc()) {
      $ecc_flaq = '--ecc ' ;
  } else {
      $ecc_flaq = q{} ;
  }

  my $cmd = 'incommon-mgr request ' .
            "--credentials-file $cm_credentials_file " .
            "--server-type '$server_type_name' " .
            "--term $duration " .
            $sans_option .
            $ecc_flaq .
            $wildcard_option .
            $test_flag .
            $csr_file
            ;

  my ($stdout, $stderr, $exit_code) = run_command($cmd) ;
  $stdout = trim($stdout) ;

  unlink($csr_file) ;

  if ($stderr)
  {
    my $msg = "command '$cmd' failed: $stderr" ;
    $self->log_error("(send) $msg");
    croak $msg ;
  }
  elsif ($stdout !~ m{^\d+$}xsm)
  {
    my $msg = "command returned an unrecognized order number: $stdout" ;
    $self->log_error("(send) $msg");
    croak $msg ;
  }
  else
  {
    $self->order_number($stdout) ;
    $self->log_info("(send) InCommon order number is $stdout");
    $self->update() ;
  }

  return 1 ;
}

# Collect the certificate(s) associated with this order number and return
# the PEM strings in an array. There are more than one certificate
# returned because InCommon returns the signing certificate chain along
# with the requested certificate.
#
# Returns an array of PEM strings.
sub collect_pem_strings
{
  my ($self) = shift ;

  my ($incommon_cm_credentials_file, $order_number) = @_ ;

  if ($order_number)
  {
    $self->order_number($order_number) ;
  }
  else
  {
    $order_number = $self->order_number() ;
  }

  if (!$order_number)
  {
    croak 'no order number!?!' ;
  }

  my %result_hash =
    Stanford::Certificate::Misc::collect($order_number, $incommon_cm_credentials_file, $self->test()) ;

  return %result_hash ;
}

# Collect a specific certificate (given by request database id), and store
# it in the database. Note that the credentials file path argument is
# required. Sends fulfillment e-mail.
#
# Returns: the certificate datbase id of the certificate collected
sub collect
{
  my ($self) = shift ;
  my ($incommon_cm_credentials_file) = @_ ;

  my $id = $self->id() ;

  if ($self->status() =~ m{new}ixsm)
  {
    croak 'cannot collect yet: certificate not yet requested' ;
  }

  my %result_hash = $self->collect_pem_strings($incommon_cm_credentials_file) ;
  my $renewid     = $result_hash{'renewid'} ;
  my @pem_strings = @{ $result_hash{'pems'} } ;

  $self->log_info('collected the PEM strings from the InCommon Certificate Manager');

  # Separate the host certificate from the root/intermediate
  # certificates (the array returns with the first element as the host
  # certificate).
  @pem_strings = Stanford::Certificate::X509::separate_pems(\@pem_strings);
  my $server_certificate = shift @pem_strings ;

  my $schema = $self->get_schema() ;

  # Save the other certificates first:
  my @other_certs = Stanford::Certificate::X509::save_pems(\@pem_strings, $schema);
  $self->log_info('found ' . scalar(@other_certs) . ' intermediate/root certificates');

  # Save the server certificate (should be only one!):
  my @server_certs = Stanford::Certificate::X509::save_pems([$server_certificate], $schema);
  $self->log_info('found ' . scalar(@server_certs) . ' server certificate');

  # Set the request's certificate_id field.
  my $server_cert = $server_certs[0] ;
  my $server_certificate_id = $server_cert->id() ;
  $self->log_info("set certificate id to $server_certificate_id");

  if (!$server_certificate_id)
  {
    croak 'could not find certificate id of the certificate downloaded' ;
  }
  else
  {
    $self->certificate_id($server_certificate_id) ;

    # Save the renew id (if it is defined)
    if (defined($renewid))
    {
      $self->renewid($renewid) ;
    }
    else
    {
      $self->log_warning('certificate collected has no renew id');
    }

    $self->update() ;

    # Copy the contact_email from the request to the certificate.
    my $contact_email = $self->contact_email() ;
    if ($contact_email) {
        $server_cert->contact_email($contact_email) ;
        $server_cert->update() ;
        $self->log_info("set certificate contact_email to '$contact_email'");
    } else {
        $self->log_warning('did not set certificate contact_email (request had no contact_email)');
    }
  }

  # Send the fulfillment e-mail
  $self->send_fulfilled_email() ;

  # If there are any LEGACY certificates with the same common name, suppress
  # these legacy certificates notifications
  my $cn = $self->cn() ;
  Stanford::Certificate::Notification::suppress_superseded_legacy_expirations($schema, $cn) ;

  return $self->certificate_id() ;
}

# Cancel a certificate request.
# NOTE!! This method only marks the record in the request database as
# cancelled. In particular, it does NOT change the request's status at the
# InCommon Certificate Manager. That must be done manually.
sub cancel
{
  my ($self) = shift ;

  $self->cancelled(1) ;
  $self->saveme() ;

  return ;
}

sub isCancelled
{
  my ($self) = shift ;

  if (defined($self->cancelled()))
  {
    my $cancelled = $self->cancelled() ;
    if ($cancelled == 1)
    {
      return 1 ;
    }
    else
    {
      return 0 ;
    }
  }
  else
  {
    return 0 ;
  }
}

# An alias in case of misspelling.
sub isCanceled
{
  my ($self) = shift ;
  return $self->isCancelled() ;
}

# Return 1 if this CSR uses an ECC public-key algorithm.
sub is_ecc {
    my ($self) = shift ;

    # Is pk_algorithm already defined?
    my $pk_algorithm ;
    if ($self->pk_algorithm()) {
        # YES!
        $pk_algorithm = $self->pk_algorithm() ;
    } else {
        eval {
            $pk_algorithm = derive_pk_algorithm_from_csr($self->csr()) ;
        } ;
        if ($EVAL_ERROR) {
            $pk_algorithm = undef ;
        }
    }

    if ($pk_algorithm) {
        if ($pk_algorithm =~ m{id-ecPublicKey}ixsm) {
            return 1 ;
        } else {
            return 0 ;
        }
    }
}

# Returns a Request object based on the parameters passed from the
# SSL request form.
#
# IMPORTANT! The request object returned has NOT been saved!
sub create_from_web_page
{
  my ($self) = shift ;

  # Set some defaults for server type and certificate type.
  my (%args) = (
                'server_type_name'      => 'Apache/ModSSL',
                'certificate_type_name' => 'normal',
                'use_test_site'         => 1,
                @_,
               ) ;

  my $schema  = $self->get_schema() ;

  ## ### ##   ## ### ##   ## ### ##   ## ### ##   ## ### ##
  my $die_if_missing_fref = sub
  {
    my ($field_name) = @_ ;

    if (!$args{$field_name})
    {
      croak "missing required '$field_name' parameter" ;
    }
  } ;
  ## ### ##   ## ### ##   ## ### ##   ## ### ##   ## ### ##
  my $die_if_not_defined_fref = sub
  {
    my ($field_name) = @_ ;

    if (!defined($args{$field_name}))
    {
      croak "required '$field_name' parameter is not defined" ;
    }
  } ;
  ## ### ##   ## ### ##   ## ### ##   ## ### ##   ## ### ##

  $die_if_missing_fref->('requester_sunetid') ;
  $die_if_missing_fref->('requester_fullname') ;
  $die_if_missing_fref->('requester_email') ;
#  $die_if_missing_fref->('requester_affiliation') ;
#  $die_if_missing_fref->('requester_department') ;
  $die_if_missing_fref->('cn') ;
  $die_if_missing_fref->('server_type_name') ;
  $die_if_missing_fref->('contact_email') ;
  $die_if_missing_fref->('duration') ;
  $die_if_missing_fref->('csr') ;
  $die_if_missing_fref->('approval_contacts') ;

  $die_if_not_defined_fref->('use_test_site') ;

  # Find the server corresponding to the name passed in the
  # 'server_type_name' parameter.
  my $server_type_name = $args{'server_type_name'} ;
  my $server_type = $schema->resultset('ServerType')->find(
        { 'name' => $server_type_name },
      );

  if (!$server_type)
  {
    croak "no server type found corresponding to '$server_type_name'" ;
  }

  # Find the certificate corresponding to the name passed in the
  # 'certificate_type_name' parameter.
  my $certificate_type_name = $args{'certificate_type_name'} ;
  my $certificate_type = $schema->resultset('CertificateType')->find(
        { 'name' => $certificate_type_name },
      );

  if (!$certificate_type)
  {
    croak "no certificate type found corresponding to '$certificate_type_name'" ;
  }


  my $request = $schema->resultset('Request')->new({});

  $request->requester_sunetid($args{'requester_sunetid'}) ;
  $request->requester_fullname($args{'requester_fullname'}) ;
  $request->requester_email($args{'requester_email'}) ;
  $request->requester_affiliation($args{'requester_affiliation'}) ;
  $request->requester_department($args{'requester_department'}) ;
  $request->requester_comments(trim($args{'requester_comments'})) ;
  $request->requester_alternatives(trim($args{'requester_alternatives'})) ;
  $request->cn($args{'cn'}) ;
  $request->contact_email($args{'contact_email'}) ;
  $request->duration($args{'duration'}) ;
  $request->csr($args{'csr'}) ;
  $request->approval_contacts($args{'approval_contacts'}) ;
  $request->server_type($server_type) ;
  $request->certificate_type($certificate_type) ;

  if (! $args{'use_test_site'}) {
      $args{'use_test_site'} = 0 ;
  }
  $request->test($args{'use_test_site'}) ;

  $request->log_info("created request object for a $certificate_type_name "
                   . 'certificate from web submission ');

  return $request ;
}

# Given a JSON object, create a Request object.
#

sub json_format_help_text {

    my $json_help_text = <<'EOT';
A certificate request can be encoded using JSON.

The JSON format expected:
{
  "csr":
"-----BEGIN CERTIFICATE REQUEST-----\nMIICzjCCAbYCAQAwgYgxCzAJBgNVBAYTAlVTMRMwEQYDVQQIEwpDYWxpZm9ybmlh\n
...-----END CERTIFICATE REQUEST-----\n",
  "contact_email" : "mylist@lists.stanford.edu",
  "duration"      : "3",
  "server_type"   : "Apache/ModSSL",
  "sans"          : [
     "mdm-dev2-adam.stanford.edu",
     "mdm-dev2-yuelu.stanford.edu"
   ],
  "is_wildcard_san"  : false,
  "comment"          : "Please expedite."
 }

All fields are required EXCEPT comment, sans, and is_wildcard_san.

Field constraints:
- duration must be one of "1", "2", or "3". Defaults to "3".

- server_type must be one of the types listed in the
InCommon API documentation. Usually server_type is one of these
strings:
  + "Microsoft IIS 5.x and later"
  + "Apache/ModSSL"
  + "Tomcat"
Defaults to "Apache/ModSSL".
EOT

    return $json_help_text ;
}

# Returns a hash reference
sub json_to_request {
    my ($json_string) = @_ ;

    my $json = JSON->new->allow_nonref;

    my $decoded = $json->decode($json_string);

    # Default duration to "1".
    if (!$decoded->{'duration'}) {
        $decoded->{'duration'} = '1' ;
    }

    # Default server_rtype to Apache.
    if (!$decoded->{'server_type'}) {
        $decoded->{'server_type'} = 'Apache/ModSSL' ;
    }

    return $decoded ;
}

# Takes a single argument: $format. If $format is not defined or set to
# the empty string, will return the full to_s information.
#
# If $format is set to 'customer_email', then to_s will return an
# abbreviated version sutiable for inclusion in a customer e-mail.
sub to_s
{
  my ($self) = shift ;
  my ($format, $credentials_file) = @_ ;

  my $id                 = $self->id() ;
  my $test               = $self->test() ;
  my $cn                 = $self->cn() ;
  my $duration           = $self->duration() ;
  my $requester_sunetid  = $self->requester_sunetid() ;
  my $requester_fullname = $self->requester_fullname() ;
  my $requester_email    = $self->requester_email() ;
  my $requester_comments = $self->requester_comments() ;
  my $requester_alternatives = $self->requester_alternatives() ;
  my $contact_email      = $self->contact_email() ;
  my $server_type        = $self->server_type() ;
  my $certificate_type   = $self->certificate_type() ;
  my $csr                = $self->csr() ;
  my $pk_algorithm       = $self->pk_algorithm() ;
  my $order_number       = $self->order_number() ;
  my $created_at         = $self->created_at() ;
  my $updated_at         = $self->updated_at() ;
  my $declined           = $self->declined() ;
  my $rejected           = $self->rejected() ;

  my $format_for_customer ;
  if ($format && ($format =~ m{customer}ixsm))
  {
    $format_for_customer = 1 ;
  }
  else
  {
    $format_for_customer = 0 ;
  }

  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###
  my $format_if_empty_fref = sub
  {
    my ($value, $empty_string) = @_ ;

    my $undefined_string ;

    # If we are formatting for a customer, we want the undefined string to
    # be empty.
    if ($format_for_customer)
    {
      $empty_string = q{} ;
      $undefined_string = q{} ;
    }
    elsif ($empty_string)
    {
      $undefined_string = $empty_string ;
    }
    else
    {
      $empty_string     = '<EMPTY_STRING>' ;
      $undefined_string = '<NONE PROVIDED>' ;
    }

    my $return_value ;
    if (!defined($value))
    {
      $return_value = $undefined_string ;
    }
    else
    {
      $value = trim($value) ;
      if (trim($value) eq q{})
      {
        $return_value = $empty_string ;
      }
      else
      {
        $return_value = $value ;
      }
    }
    return $return_value ;
  } ;
  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###  # ## ###

  $id                 = $format_if_empty_fref->($id) ;
  $cn                 = $format_if_empty_fref->($cn) ;
  $requester_sunetid  = $format_if_empty_fref->($requester_sunetid) ;
  $order_number       = $format_if_empty_fref->($order_number, 'NO ORDER NUMBER') ;
  $requester_comments = $format_if_empty_fref->($requester_comments) ;
  $requester_alternatives = $format_if_empty_fref->($requester_alternatives) ;
  $contact_email      = $format_if_empty_fref->($contact_email) ;

  # server type
  my $server_type_name ;
  if ($server_type)
  {
    $server_type_name  = $server_type->name() ;
  }
  else
  {
    $server_type_name  = $format_if_empty_fref->(undef) ;
  }

  # certificate type
  my $certificate_type_name ;
  if ($certificate_type)
  {
    $certificate_type_name  = $certificate_type->name() ;
  }
  else
  {
    $certificate_type_name  = $format_if_empty_fref->(undef) ;
  }

  # csr
  my $csr_subject ;
  my $csr_md5 ;
  if ($csr)
  {
    my @objects = Stanford::PKObj::get_objects_from_string($csr) ;
    my $pkobj_csr ;
    if (scalar(@objects) > 0) {
      $pkobj_csr = $objects[0] ;

      my %field_to_value = Stanford::PKObj::parse_req($csr) ;

      $csr_subject = $field_to_value{'subject'} ;
      $csr_md5     = $pkobj_csr->get_md5() ;

    } else {
      $pkobj_csr   = '<ERROR! COULD NOT PARSE CSR>' ;
      $csr_subject = '<ERROR! COULD NOT PARSE CSR>' ;
      $csr_md5     = '<ERROR! COULD NOT PARSE CSR>' ;
    }
  }

  my $status ;
  eval {
      $status = $self->status($credentials_file) ;
  } ;

  my $status_error = $EVAL_ERROR ;
  if ($status_error) {
      $status = 'ERROR retrieving request status; see below for detail' ;
      $status_error = "\nERROR REPORT: $status_error" ;
  }

  my $cancelled_string = q{} ;
  if ($self->isCancelled())
  {
    $cancelled_string = q{ (cancelled)} ;
  }

  my $reissue_string = ($self->reissue() ? 'YES' : 'NO') ;

  my $approved_formatted ;
  if ($self->approved())
  {
    $approved_formatted = 'YES' ;
  }
  else
  {
    $approved_formatted = 'NO' ;
  }

  my $approval_contacts = $self->approval_contacts() ;

  my $certificate_id = $self->certificate_id() ;

  if (!$certificate_id) {
      if ($declined) {
          $certificate_id = 'N/A (request declined)' ;
      } else {
          $certificate_id = 'no certificate yet' ;
      }
  }

  my $renewid = $self->renewid() ;
  $renewid    = $format_if_empty_fref->($renewid, 'NO RENEW ID') ;

  my $testing_formatted ;
  my $test_yes_or_no ;
  if ($test)
  {
    $test_yes_or_no    = 'YES' ;
    $testing_formatted = ' [TEST]' ;
  }
  else
  {
    $test_yes_or_no    = 'NO' ;
    $testing_formatted = q{};
  }

  # dates
  $created_at = mysql_time_local($created_at) ;
  $updated_at = mysql_time_local($updated_at) ;

  my $suppressed = 'NO' ;
  my $suppressed_note = q{} ;
  if ($self->suppress_notifications()) {
      $suppressed = 'YES' ;
      $suppressed_note = ' (suppressed)' ;
  }

  my $declined_formatted ;
  if ($declined) {
      $declined_formatted = 'YES' ;
  } else {
      $declined_formatted = 'NO' ;
  }

  my $rejected_formatted ;
  if ($rejected) {
      $rejected_formatted = 'YES' ;
  } else {
      $rejected_formatted = 'NO' ;
  }

  my $duration_years ;
  if ($duration == 1) {
      $duration_years = '1 year' ;
  } else {
      $duration_years = "$duration years" ;
  }

  my $rv ;
  if ($format_for_customer)
  {
    $rv = <<~"EOR";
        cn (common name):          $cn
        requester_sunetid:         $requester_sunetid
        requester_fullname:        $requester_fullname
        requester_email:           $requester_email
        contact_email:             $contact_email
        server_type_name:          $server_type_name
        certificate_type_name:     $certificate_type_name
        duration:                  $duration_years
        InCommon order number:     $order_number
        CSR md5:                   $csr_md5
        CSR public key algorithm:  $pk_algorithm
        requester_comments:        $requester_comments
        requester_alternatives:    $requester_alternatives
        EOR
  }
  else
  {
    $rv = <<~"EOS";
        database id:               $id
        cn (common name):          $cn
        test?:                     $test_yes_or_no
        status:                    ${status}${cancelled_string}
        reissue:                   $reissue_string
        approved?:                 $approved_formatted
        certificate id:            $certificate_id
        requester_sunetid:         $requester_sunetid
        requester_fullname:        $requester_fullname
        requester_email:           $requester_email
        contact_email:             $contact_email$suppressed_note
        server_type_name:          $server_type_name
        certificate_type_name:     $certificate_type_name
        duration:                  $duration_years
        InCommon order number:     $order_number$testing_formatted
        renewID:                   $renewid
        CSR md5:                   $csr_md5
        CSR public key algorithm:  $pk_algorithm
        CSR subject:               $csr_subject
        created on:                $created_at
        updated on:                $updated_at
        requester_comments:        $requester_comments
        requester_alternatives:    $requester_alternatives
        approvers:                 $approval_contacts
        notifications suppressed?: $suppressed
        declined?:                 $declined_formatted
        rejected?:                 $rejected_formatted
        $status_error
        EOS
  }

  return $rv ;
}

# The URL for the InCommon Certificate Manager. There is a different URL
# for the production InCommon Certificate Manager and the test InCommon
# Certificate Manager.
sub manager_url
{
  my ($self) = shift ;

  if ($self->test())
  {
    # TEST
    return 'https://cert-manager.com/customer/InCommon_test' ;
  }
  else
  {
    # PRODUCTION
    return 'https://cert-manager.com/customer/InCommon' ;
  }
}

# Send a notification to the approvers that an approval is needed.
sub notify_approvers
{
  my ($self) = shift ;
  my (%args) = (
                'special_handling' => 0,
                @_,
               ) ;

  my $id = $self->id() ;

  my $special_handling = $args{'special_handling'} ;

  my $approval_contacts = $self->approval_contacts() ;

  if (!$approval_contacts)
  {
    croak 'cannot notify of request send without approval contacts' ;
  }

  my $cn = $self->cn() ;
  my $requester_email = $self->requester_email() ;

  my $request_string = $self->to_s() ;

  my $manager_url = $self->manager_url() ;
  my ($test_text, $test_text_body, $remctl_server) ;
  if ($self->test())
  {
    # TEST
    $test_text      = '[TEST] ' ;
    $test_text_body = 'Test ' ;
    $remctl_server  = 'certreq-dev' ;
  }
  else
  {
    # PRODUCTION
    $test_text      = q{} ;
    $test_text_body = q{};
    $remctl_server  = 'certreq' ;
  }

  my $order_number = $self->order_number() ;

  # SUBJECT
  my $subject      = undef ;
  my $message_body = undef ;

  # Cases:
  # 1. Reissue certificate.
  # 2. Non-reissued multi-domain-name certificate
  # 3. Non-reissued single domain-name certificate
  if ($self->reissue())
  {
    $subject = "${test_text}Special handling for reissue of SSL Certificate needed: $cn" ;

    # We do NOT use HEREDOCS in the message body because we want the lines in the messages
    # to be unbroken.
    ## no critic (ValuesAndExpressions::ProhibitInterpolationOfLiterals);
    $message_body =
        "--> WARNING! Reissue certificate request WARNING! <--" .
        "\n\n" .
        "The X509 certificate with subject '$cn' requested by " .
        "$requester_email is a REISSUE request. The CSR is included after " .
        "this message." .
        "\n\n" .
        "1. Go to the ${test_text_body}web site $manager_url and " .
        "order the certificate using the included CSR." .
        "\n\n" .
        "2. While still at the InCommon Certificate Manager site, " .
        "find the InCommon order number (click the details box and look " .
        q{for "Self-Enrollment Certificate ID").} .
        "\n\n" .
        "3. Using the order number from step 2, set it for this request: " .
        "remctl $remctl_server certreq set-order-number $id <order_number>" .
        "\n\n" . $self->csr() .
        "\n\n" . $request_string
    ;
    ## use critic
  }
  elsif ($special_handling)
  {
    $subject = "${test_text}Special handling for non-single domain-name SSL Certificate needed: $cn" ;
    ## no critic (ValuesAndExpressions::ProhibitInterpolationOfLiterals);
    $message_body =
      "--> WARNING! Non-single domain certificate request WARNING! <--" .
      "\n\n" .
      "The X509 certificate with subject '$cn' requested by $requester_email " .
      "is *not* a single domain-name certificate. " .
      "Please go to the InCommon ${test_text_body}web site $manager_url " .
      "and verify that the certificate TYPE is correct BEFORE approving. " .
      "The Incommon order number for this request is $order_number" .
      "\n\n\n" . $request_string
    ;
    ## use critic
  }
  else
  {
    $subject = "${test_text}SSL Certificate approval needed: $cn" ;
    ## no critic (ValuesAndExpressions::ProhibitInterpolationOfLiterals);
    $message_body =
      "The X509 certificate with subject '$cn' requested by $requester_email " .
      "has been accepted by InCommon (order number $order_number) " .
      "and now needs your approval. " .
      "Please go to the InCommon ${test_text_body}web site " .
      "$manager_url to approve this request." .
      "\n\n\n" . $request_string
    ;
    ## use critic
  }

  my @approval_contacts_array = $self->approval_contacts_array() ;
  if (scalar(@approval_contacts_array) == 0)
  {
      $self->log_error('no approval e-mail contacts?!?') ;
  }
  else
  {
    foreach my $approval_contact (@approval_contacts_array)
    {
      $self->log_info("sending approval e-mail to '$approval_contact'") ;
      Stanford::Certificate::Mail::send_email(
                 'to'      => $approval_contact,
                 'subject' => $subject,
                 'body'    => $message_body,
                      ) ;
    }
  }

  return 1;
}

# Send e-mail to the contacts e-mail address.
sub send_to_contacts {
    my ($self) = shift ;
    my (%args) = (
                  @_,
                 ) ;

    $args{'send_to_contacts'}  = 1 ;
    $args{'send_to_approvers'} = 0 ;
    return $self->send_to_contacts_and_or_approvers(%args) ;
}

sub send_to_approvers {
    my ($self) = shift ;
    my (%args) = (
                  @_,
                 ) ;

    $args{'send_to_contacts'}  = 0 ;
    $args{'send_to_approvers'} = 1 ;
    return $self->send_to_contacts_and_or_approvers(%args) ;
}

sub send_to_contacts_and_approvers {
    my ($self) = shift ;
    my (%args) = (
                  @_,
                 ) ;

    $args{'send_to_contacts'}  = 1 ;
    $args{'send_to_approvers'} = 1 ;
    return $self->send_to_contacts_and_or_approvers(%args) ;
}

sub send_to_contacts_and_or_approvers {
    my ($self) = shift ;
    my (%args) = (
                  'send_to_contacts'  => undef,
                  'send_to_approvers' => undef,
                  @_,
                 ) ;

    if (!$args{'subject'}) {
        croak 'missing subject' ;
    }

    my $send_to_contacts  = $args{'send_to_contacts'} ;
    my $send_to_approvers = $args{'send_to_approvers'} ;

    my $contact_addresses_cs  ;
    my $approval_addresses_cs ;

    if ($send_to_contacts) {
        my @contact_addresses = $self->contact_addresses() ;
        $contact_addresses_cs = join(q{,}, @contact_addresses) ;
    } else {
        $contact_addresses_cs = undef ;
    }

    if ($send_to_approvers) {
        my @approval_addresses = $self->approval_contacts_array() ;
        $approval_addresses_cs = join(q{,}, @approval_addresses) ;
    } else {
        $approval_addresses_cs = undef ;
    }

    Stanford::Certificate::Mail::send_email(
        'to'      => $contact_addresses_cs,
        'cc'      => $approval_addresses_cs,
        'subject' => $args{'subject'},
        'body'    => $args{'body'},
    ) ;

    return ;
}

# Sends fulfullment e-mail to the contact_addresses.
sub send_fulfilled_email
{
  my ($self) = shift ;

  my $cn = $self->cn() ;

  # Get the e-mail body:
  my $body = $self->fulfilled_email_body() ;

  # Make the subject:
  my $subject =  q{Enrollment Successful - Your SSL certificate for } .
                qq{$cn is ready} ;

  $self->send_to_contacts_and_approvers(
    'subject' => $subject,
    'body'    => $body,
      ) ;

  return ;
}

# Construct the body of the e-mail sent to requester when
# certificate has been fulfilled.
sub fulfilled_email_body
{
  my ($self) = shift ;

  my $order_number = $self->order_number() ;
  my $renewid      = $self->renewid() ;
  my $cn           = $self->cn() ;
  my $duration     = $self->duration() ;
  my $server_type  = $self->server_type() ;

  my $certificate  = $self->certificate() ;
  my $expires_at   = $certificate->expires_at() ;
  my @sans = $certificate->sans()->all() ;
  my @san_names = () ;
  foreach my $san (@sans)
  {
    push (@san_names, $san->name()) ;
  }
  my $sans_formatted = join(', ', @san_names) ;

  my $duration_years ;
  if ($duration == 1)
  {
    $duration_years = '1 Year' ;
  }
  else
  {
    $duration_years = "$duration Years" ;
  }

  my $server_type_name ;
  if ($server_type)
  {
    $server_type_name  = $server_type->name() ;
  }
  else
  {
    $server_type_name  = q{} ;
  }

  my $manager_url = $self->manager_url() ;
  my $cert_url = qq{$manager_url/ssl?action=download&sslId=$order_number};

  my ($first_choice, $other_formats) ;
  if ($server_type_name =~ m{Microsoft IIS}sm)
  {
    $first_choice = <<"EOB";
       as PKCS#7 Base64 encoded: $cert_url&format=base64
EOB

    $other_formats = <<"EOX";
       as PKCS#7 Bin encoded: $cert_url&format=bin
       as X509 Certificate only, Base64 encoded: $cert_url&format=x509CO
       as X509 Intermediates/root only, Base64 encoded: $cert_url&format=x509IO
       as X509 Intermediates/root only Reverse, Base64 encoded: $cert_url&format=x509IOR
EOX

  }
  else
  {
    $first_choice = <<"EOC";
       as X509 Certificate only, Base64 encoded: $cert_url&format=x509CO
       as X509 Intermediates/root only, Base64 encoded: $cert_url&format=x509IO
       as X509 Intermediates/root only Reverse, Base64 encoded: $cert_url&format=x509IOR
EOC

    $other_formats = <<"EOY";
       as PKCS#7 Base64 encoded: $cert_url&format=base64
       as PKCS#7 Bin encoded: $cert_url&format=bin
       as X509, Base64 encoded: $cert_url&format=x509
EOY

  }

  return <<"EOS";
Hello,

You have successfully enrolled for an InCommon SSL certificate.

You now need to complete the following steps:

    * Click the following link to download your SSL certificate (generally
      try to use a version that includes intermediates & root or your
      certificate may be rejected by some older clients)

    Format(s) most suitable for your server software:
$first_choice

    Other available formats:
$other_formats

    * Import your new certificate into your server (Please contact your
      administrator for help with this).

    * Your renew id: $renewid

Certificate Details:
    Common Name :  $cn
    Subject Alternative Names : $sans_formatted
    SSL Type :     InCommon SSL
    Term :         $duration_years
    Server :       $server_type_name
    Expires :      $expires_at
    Self-Enrollment Certificate ID : $order_number
EOS

}


# Returns false if no certificates found.
sub findById {
  my ($self) = shift ;

  my ($id) = @_ ;

  my $schema = $self->result_source->schema ;

  my $reqs = $schema->resultset('Request')->search(
        { id => $id },
  );

  if ($reqs)
  {
    my @all_reqs = $reqs->all() ;
    my $num_results = scalar(@all_reqs) ;
    if ($num_results > 1)
    {
        croak "found more than one certificate with id '$id'!!)" ;
    } elsif ($num_results == 1) {
        my $req = $all_reqs[0] ;
        return $req ;
    } else {
        return ;
    }
  }

  return ;
}

# Returns a false value if no requests found.
sub findByOrderNumber {
    my ($self) = shift ;

    my ($order_number) = @_ ;

    my $schema = $self->result_source->schema ;

    my $reqs = $schema->resultset('Request')->search(
        { order_number => $order_number },
        );

    if ($reqs) {
        my @all_reqs = $reqs->all() ;
        if (@all_reqs) {
            if (scalar(@all_reqs) > 1) {
                croak "found more than one request with order number '$order_number'!!)" ;
            } elsif (scalar(@all_reqs) == 1) {
                my $req = $all_reqs[0] ;
                return $req ;
            } else {
                return ;
            }
        }

        # If we get here, then we did not find a request with the supplied order
        # number. In this case we return a false value.
        return ;
    }
}

# Returns undef if no request found. Dies if more than one found.
sub findByCertificateId {
    my ($self) = shift ;

    my ($certificate_id) = @_ ;

    my $schema = $self->result_source->schema ;

    my $reqs = $schema->resultset('Request')->search(
        { certificate_id => $certificate_id },
        );

    if ($reqs) {
        my @all_reqs = $reqs->all() ;
        if (@all_reqs) {
            if (scalar(@all_reqs) > 1) {
                croak "found more than one request with certificate id '$certificate_id'!!)" ;
            } elsif (scalar(@all_reqs) == 1) {
                my $req = $all_reqs[0] ;
                return $req ;
            } else {
                return ;
            }
        }

        # If we get here, then we did not find a request with the supplied certificate
        # id. In this case we return a false value.
        return ;
    }
}

# Send the "interested parties" an e-mail telling them that the
# certificate order has been sent to InCommon and that we have an order
# number.
#
# The "interested parties" are:
#  * requester_email
#  * contact_email
#  * approvers list (No, don't Cc: the approvers)
#
sub notify_sent {
  my ($self) = shift ;

  # Get the order number. If this is NOT a re-issue, die if there is no
  # order number.
  my $order_number = $self->order_number() ;

  if (!$self->reissue() && !$order_number)
  {
    croak 'cannot send order submitted e-mails without an order number' ;
  }

  # Get the interested party e-mails
  my $requester_email = $self->requester_email() ;
  my $contact_email   = $self->contact_email() ;

  my @contact_addresses = $self->contact_addresses() ;


  if (scalar(@contact_addresses) == 0)
  {
    croak 'cannot send notification without at least one requester or contact e-mail' ;
  }

  my ($test_text, $test_text_body) ;
  my $manager_url ;

  if ($self->test())
  {
    # TEST
    $test_text      = '[TEST] ' ;
    $test_text_body = 'Test ' ;
    $manager_url    = 'https://cert-manager.com/customer/InCommon_test' ;
  }
  else
  {
    # PRODUCTION
    $test_text      = q{} ;
    $test_text_body = q{};
    $manager_url    = 'https://cert-manager.com/customer/InCommon' ;
  }


  # We want to put the certificate's Common Name in the e-mail text.
  my $cn = $self->cn() ;

  # SUBJECT
  my $subject = "${test_text}SSL Certificate order for $cn placed" ;

  # As usual, we put the original web request information at the end of
  # the e-mail.
  my $request_string = $self->to_s('customer_email') ;

  # For re-issues, we suppress the order number information.
  my $incommon_order_number_sentence ;
  if ($self->reissue())
  {
    # RE-ISSUE
    $incommon_order_number_sentence = q{} ;
  }
  else
  {
    # NON RE-ISSUE
    $incommon_order_number_sentence =
        "The InCommon order number is $order_number. " ;
  }

  ## no critic (ValuesAndExpressions::ProhibitInterpolationOfLiterals);
  my $message_body =
        "The X509 certificate with subject '$cn' you requested "
      . "has been submitted for processing. "
      . $incommon_order_number_sentence
      . "You will receive an update via e-mail when the certificate "
      . "is ready for downloading. "
      . "\n\n\n" . $request_string
    ;
  ## use critic

  $self->send_to_contacts(
    'subject' => $subject,
    'body'    => $message_body,
      ) ;

  return 1;
}

# Given a request object, return an array of validation error text lines
# if the request is invalid. If everything is valid, return the empty
# list.
#
# VALIDATIONS
#
#  1. There must be a CN.
#  2. There must be a contact e-mail address.
#  3. There must be a CSR and it must be well-formed.
#  4. The type is UCC if, and only if, there are SANs.
#  5. The CN is *.something if, and only if, type is wildcard.
#  6. Do not allow a wildcard certificate to have SANs.
#  7. Make sure the SANs are valid hostname strings and that are not too many.
#  8. Do not allow any of the names to be "stanford.edu" or "*.stanford.edu".
#  N. (NetDB) Verify that the requester has the authority to request.

sub validate_request {
    my ($self) = shift ;

    my ($requester) = @_ ;

    my @errors = () ;
    my $msg ;

    my @hostnames = () ;
    my @sans      = () ;

    # Create the list of all SANs.
    if ($self->requester_alternatives()) {
        my @sansx = split(q{,}, $self->requester_alternatives()) ;
        foreach my $sanx (@sansx) {
            push(@sans, trim($sanx)) ;
        }
    }

    # Collect the CN and all SANs into a single array.
    push(@hostnames, $self->cn()) ;
    push(@hostnames, @sans) ;

    # ## #     # ## #     # ## #     # ## #     # ## #     # ## #

    # Step 1. Is there a cn?
    if (!$self->cn()) {
        $msg = 'missing certificate CN' ;
        push (@errors, $msg) ;
    }


    # Step 2. Is there a contact e-mail address?
    if (!$self->contact_email()) {
        $msg = 'missing a contact e-mail address' ;
        push (@errors, $msg) ;
    }

    # Step 3A. Is there a CSR?
    my $csr_subject ;
    if (!$self->csr()) {
        $msg = 'missing the CSR' ;
        push (@errors, $msg) ;
    } else {
        # Step 3B. Is the CSR valid?
        my $csr = $self->csr() ;

        my @objects = Stanford::PKObj::get_objects_from_string($csr) ;
        my $pkobj_csr ;
        if (scalar(@objects) > 0) {
            $pkobj_csr = $objects[0] ;

            my %field_to_value = Stanford::PKObj::parse_req($csr) ;

            $csr_subject = $field_to_value{'subject'} ;
            if (!$csr_subject) {
                $msg = 'the CSR does not appear to have a subject' ;
                push (@errors, $msg) ;
            }
        } else {
            $msg = 'the CSR string is not valid' ;
            push (@errors, $msg) ;
        }
    }

    # Step 4. SANs iff type is UCC.
    if ($self->requester_alternatives() &&
        (!$self->certificate_type()->is_UCC())) {
        $msg = q{you have SAN's but the certificate type is not UCC} ;
        push (@errors, $msg) ;
    }
    if ((!$self->requester_alternatives()) &&
        $self->certificate_type()->is_UCC()) {
        $msg = q{your certificate type is UCC but you don't have any SAN's} ;
        push (@errors, $msg) ;
    }

    # Step 5. CN is *.something iff type is wildcard.
    if (($self->cn() =~ m{^[*]}xsm) &&
        (!$self->certificate_type()->is_wildcard())) {
        $msg = q{your CN has a wildcard but the certificate type is not wildcard} ;
        push (@errors, $msg) ;
    }
    if (($self->cn() !~ m{^[*]}xsm) &&
        ($self->certificate_type()->is_wildcard())) {
        $msg = q{your certificate type is wildcard but your CN does not have a '*'} ;
        push (@errors, $msg) ;
    }

    # Step 6. Do not allow a wildcard certificate to have SANs.
    if ($self->certificate_type()->is_wildcard() &&
        $self->requester_alternatives()) {
        $msg = q{wildcard certs are not allowed to have alternative names} ;
        push (@errors, $msg) ;
    }

    # Step 7. Make sure the SANs are valid hostnames and that are not too many.
    if ($self->requester_alternatives()) {
        # too many?
        if (scalar(@sans) > 100) {
            $msg = q{you cannot have more than 100 Subject Alternative Names} ;
            push (@errors, $msg) ;
        }

        # hostname is well-formed.
        foreach my $san (@sans) {
            if (!valid_hostname($san)) {
                $msg = qq{the Subject Alternative Name '$san' is not a valid hostname} ;
                push (@errors, $msg) ;
            }
        }
    }

    # Step 8. Make sure that none of the hostnames are "stanford.edu" or "*.stanford.edu".
    foreach my $hostname (@hostnames) {
        if ($hostname eq 'stanford.edu') {
            $msg = q{you are not permitted to request a certificate for 'stanford.edu'} ;
            push (@errors, $msg) ;
        }

        if ($hostname eq '*.stanford.edu') {
            $msg = q{you are not permitted to request a certificate for '*.stanford.edu'} ;
            push (@errors, $msg) ;
        }
    }

    # Step N.

    # To save time, if there are any errors at this point skip this test.
    if (@errors) {
        return @errors ;
    }

    # First we get the NetDB information for all the hostnames.
    my $netdbinfo = get_netdb_info($requester, \@hostnames, $self->test()) ;

    # We loop through names to check finding any that are problematic.
    foreach my $hostname (@hostnames) {
        ## See if there was an error with this hostname.
        my $err_string = netdb_validate_hostname($hostname, $netdbinfo) ;

        if ($err_string) {
            ## There was a problem.
            push(@errors, $err_string) ;
        }
    }

    return @errors ;
}

sub valid_hostname {
    my ($hostname) = @_ ;

    if ($hostname =~ m{^([*][.]){0,1}[[:lower:]][[:lower:]\d.-]+$}ixsm) {
        return 1 ;
    } else {
        return 0 ;
    }
}

# Set the certificate type based on CN and SAN's.
sub infer_cert_type {
    my $self = shift ;

    my $cn = $self->cn() ;
    my $requester_alternatives = $self->requester_alternatives() ;

    my $certificate_type_name ;

    if (!$cn) {
        croak 'no CN!';
    } elsif ($cn =~ m{^[*][.]}xsm) {
        # This is a wildcard certificate.
        $certificate_type_name = 'wildcard' ;
    } elsif ($requester_alternatives) {
        $certificate_type_name = 'ucc' ;
    } else {
        $certificate_type_name = 'normal' ;
    }

    my $schema = $self->result_source->schema ;

    my $certificate_type = $schema->resultset('CertificateType')->find(
        { 'name' => $certificate_type_name },
        );

    if (!$certificate_type) {
        croak "no certificate type found corresponding to '$certificate_type_name'" ;
    } else {
        $self->certificate_type($certificate_type) ;
    }

    return $certificate_type ;
}



# Returns a hash with these keys:
#
#  to_email_override
#  incommon_cm_credentials_yaml_file
#  db_connect_yaml_file
#  incommon_approvers
#  validate_hostname_access_via_netdb
sub get_config {
  my ($cfg_yaml_file) = @_ ;

  if (!$cfg_yaml_file)
  {
    croak 'missing config file' ;
  }

  if (!(-f $cfg_yaml_file))
  {
    croak "missing or unreadable config file '$cfg_yaml_file'" ;
  }

  my %config_key_to_value = () ;

  my $yaml = YAML::Tiny->new;
  $yaml = YAML::Tiny->read($cfg_yaml_file);
  if (!defined($yaml))
  {
    croak "failed to parse '$cfg_yaml_file' as a YAML file: "
        . YAML::Tiny->errstr() ;
  }

  my %keys_to_mandatory = (
    'use_prod_certmanager'               => 1,
    'from_email_address'                 => 0,
    'to_email_override'                  => 0,
    'incommon_cm_credentials_yaml_file'  => 1,
    'db_connect_yaml_file'               => 1,
    'incommon_approvers'                 => 1,
    'validate_hostname_access_via_netdb' => 1,
  ) ;

  foreach my $key (keys %keys_to_mandatory) {
      if (exists($yaml->[0]->{$key})) {
	  $config_key_to_value{$key} = $yaml->[0]->{$key} ;
      } elsif ($keys_to_mandatory{$key}) {
	  carp "config file missing parameter '$key'" ;
      } else {
          # key is not in config but not mandatory, so do nothing.
      }
  }

  # Die if missing important ones
  if (!$config_key_to_value{'from_email_address'}) {
      croak q{missing 'from_email_address' configuration directive} ;
  }

  return %config_key_to_value ;
}



sub format4logging
{
  my ($self) = shift ;
  my ($msg) = @_ ;

  my $cn = $self->cn() ;
  if (!$cn)
  {
    $cn = 'NONE' ;
  }

  return qq{[$cn] $msg} ;
}

sub log_info
{
  my ($self) = shift ;
  my ($msg) = @_ ;

  return Stanford::Certificate::Log::INFO($self->format4logging($msg)) ;
}

sub log_warning
{
  my ($self) = shift ;
  my ($msg) = @_ ;

  return Stanford::Certificate::Log::WARNING($self->format4logging($msg)) ;
}

sub log_error
{
  my ($self) = shift ;
  my ($msg) = @_ ;

  return Stanford::Certificate::Log::ERROR($self->format4logging($msg)) ;
}

sub expiring_requests
{
  my ($self) = shift ;
  my ($dc, $lower, $upper) = @_ ;
  return Stanford::Certificate::Notification::expiring_requests(
                                 $self->get_schema(), $dc, $lower, $upper
                                                               );
}

sub send_expiration_warning_email
{
  my ($self) = shift ;

  my $contact_email = $self->contact_email() ;
  if (!$contact_email)
  {
    croak 'could not send email expiration warning as there is not contact e-mail' ;
  }

  my $cn = $self->cn() ;
  my $cn_uppercase = uc($cn) ;

  my $certificate = $self->certificate() ;
  my $expires_at_gmt   = $certificate->expires_at() ;
  my $expires_at_local =
      Stanford::Certificate::Misc::mysql_time_local($expires_at_gmt) ;

  # We want only the date part of $expires_at
  my $expires_at_date_local =
    Stanford::Certificate::Misc::mysql_to_friendly_date($expires_at_local);

  Stanford::Certificate::Notification::send_warning_email(
    $cn_uppercase, $expires_at_date_local, $contact_email, $certificate
  ) ;

  return ;
}

# If the argument $status_details is not empty, show detailed
# status (slow).
sub format_as_request_for_list {
    my $self = shift ;
    my ($status_details, $incommon_cm_credentials_file) = @_ ;

    my $id = $self->id() ;
    my $cn = $self->cn() ;

    my $status ;
    if ($status_details) {
        if (!$incommon_cm_credentials_file) {
            croak 'cannot show status details without an InCommon ' .
                  'credentials file' ;
        }
        $status = $self->status($incommon_cm_credentials_file) ;
    } else {
        $status = $self->status() ;
    }

    my $order_number = trim($self->order_number()) ;
    if (!$order_number) {
        $order_number = q{} ;
    }

    my $reissue_string = q{} ;
    if ($self->reissue()) {
        $reissue_string = ' (reissue)' ;
    }

    # Contact e-mail
    my $contact_email = $self->contact_email() ;

    # If this request has a certificate, get that certificate information
    # now.
    my $certificate = $self->certificate() ;
    my $certificate_info = q{} ;
    if ($certificate) {
        my $expires_at_gmt   = $certificate->expires_at() ;
        my $expires_at_local =
            Stanford::Certificate::Misc::mysql_time_local($expires_at_gmt) ;
        $certificate_info = $expires_at_local ;
        $certificate_info =~ s{\s*\d\d:\d\d:\d\d$}{}xsm ;
    }

    # 40 characters should be enough for almost all CN's.
    my $first_line = sprintf("%7u %10s %7s %-40s%s %-30s\n",
      $id, $status, $order_number, $cn, $reissue_string, $contact_email) ;

    my $second_line = q{} ;
    if ($certificate_info) {
        $second_line = q{ } x 27 . sprintf("(expires %s)\n", $certificate_info) ;
    }

    return $first_line . $second_line ;
}

sub format_list_header {
    return sprintf("%7s %10s %7s %-40s %-30s\n", 'id', 'status', 'order #',
                   'cname', 'contact') ;
}

# Takes as input the requester sunetid and a (reference to an) array of
# hostnames.
#
# Returns the hash mapping
#
#   $hostname => [$node_control_results, $domain_control_results]
#
# where $node_control_results and $domain_control_results are values in
# the hash %NETDB_RESULTS.
#
# Raises an exception if the external script used to gather this
# information fails.
sub get_netdb_info {
    my ($requester, $hostnames_aref, $use_test_netdb) = @_ ;

    my @hostnames = @{$hostnames_aref} ;

    # We remove any leading '*.' prefixes.
    my @hostnames_stripped = () ;
    foreach my $hostname (@hostnames) {
        $hostname =~ s{^[*][.]}{}xsm ;
        push(@hostnames_stripped, $hostname) ;
    }

    # Remove any duplicates.
    my %names_indicator = () ;
    foreach my $hostname (@hostnames_stripped) {
        $names_indicator{$hostname} = 1 ;
    }

    my @hostnames_unique = keys %names_indicator ;

    # Construct the string that netdb-access-info-for-ssl wants:
    # Example: adamhl,mdm1.stanford.edu;adamhl,mdm2.stanford.edu
    my @tuples = map { $requester . q{,} . $_ } @hostnames_unique ;

    # $fs is the field separator
    my $fs = q{:} ;

    my $query_string = join($fs, @tuples) ;

    # Construct the command: either
    #
    #  "netdb-access-info-for-ssl $query_string"
    #
    # or
    #
    #  "netdb-access-info-for-ssl -t $query_string"
    my @cmd = qw( netdb-access-info-for-ssl ) ;

    if ($use_test_netdb) {
        # The configuration says to not use the non-production version of
        # NetDB, so add the '-t' option.
        push(@cmd, '-t') ;
    }

    # Add the query string and we are done constructing the command:
    push(@cmd, $query_string) ;

    my $keytab_file = '/etc/certreq/netdb-access.keytab' ;
    my ($stdout, $stderr, $rc) = run_under_keytab(\@cmd, $keytab_file) ;

    if ($stderr) {
        croak "problem running netdb-access-info-for-ssl: $stderr" ;
    } else {
        ## Parse the results. The results come back in this format:
        ## user1,hostname1,RESULT ;user2,hostname2,RESULT
        return Stanford::NetDBInfo->new('results' => $stdout) ;
    }
}

sub netdb_validate_hostname {
    my ($hostname, $netdbinfo) = @_ ;

    if (is_wildcard($hostname)) {
        ### WILDCARD REQUEST
        my $domain = $hostname ;
        $domain =~ s{^[*][.]}{}xsm ;

        ### DOMAIN
        my $generic_domain_help = <<~"EOR";
            To request a wildcard certificate for '$domain' there
            must exist in NetDB a DOMAIN object for '$domain'
            and you must be an Admin for that
            DOMAIN object. Please contact Networking for help setting this up.
            EOR

        # DOMAIN does not exist.
        if (!$netdbinfo->domain_exists($domain)) {
            my $err_string = <<~"EOW";
                The name '$domain' does not exist in NetDB as a
                DOMAIN object.
                $generic_domain_help
                EOW
            return $err_string ;
        } elsif ($netdbinfo->controls_domain($domain)) {
            ## DOMAIN exists and user controls it.
            return q{} ;
        } else {
            ## DOMAIN exists and user does NOT control it.
            my $err_string = <<~"EOW";
                You do not have 'Use as name' access to the
                DOMAIN object '$domain' in NetDB.
                $generic_domain_help
                EOW
            return $err_string ;
        }
    } else {
        ### NON-WILDCARD REQUEST

        ### NODE
        my $generic_node_help = <<~"EOR";
            To request a certificate for '$hostname' there must exist in NetDB a
            NODE object for '$hostname' and you must be in either the User or Admin
            field for that node.
            EOR

        # NODE or DOMAIN does not exist.
        if ((!$netdbinfo->node_exists($hostname)) && (!$netdbinfo->domain_exists($hostname))) {
            my $err_string = <<~"EOW";
                The name '$hostname' does not exist in NetDB as a NODE or DOMAIN object.
                $generic_node_help
                EOW
            return $err_string ;
        } elsif ($netdbinfo->controls_node($hostname)) {
            ## NODE exists and user controls it.
            return q{} ;
        } elsif ($netdbinfo->controls_domain($hostname)) {
            ## DOMAIN exists and user controls it.
            return q{} ;
        } else {
            ## NODE or DOMAIN exists but user does NOT control it.
            my $object_string ;
            if ($netdbinfo->node_exists($hostname)) {
                if ($netdbinfo->domain_exists($hostname)) {
                    $object_string = 'NODE or DOMAIN';
                } else {
                    $object_string = 'NODE';
                }
            } else {
                $object_string = 'DOMAIN';
            }
                    my $err_string = <<~"EOW";
                        You do not have User or Admin access to the $object_string
                        object '$hostname' in NetDB.
                        $generic_node_help
                        EOW
            return $err_string ;
        }
    }

    # If we get here, some sort of unknown error.
    my $unknown_error = 'An unknown error occured. Please contact the SSL '
      . 'Certificate provisioning administrators.' ;

    return $unknown_error ;
}

1;
